#include "contiki.h"
#include "dev/leds.h"
#include "lib/random.h"
#include "sys/ctimer.h"
#include "sys/etimer.h"

#include <stdio.h> /* For printf() */

/*---------------------------------------------------------------------------*/
static struct etimer et_hello; // On déclare un "timer" qui nous permettra de gérer le temps
static uint16_t count; // Variable permettant de compter le nombre de cycle
static uint8_t blinks; // Variable permettant de gérer le clignotement des LEDs
/*---------------------------------------------------------------------------*/
PROCESS(hello_world_process, "[Exemple] Hello world avec affichage des LED");
AUTOSTART_PROCESSES(&hello_world_process);
/*---------------------------------------------------------------------------*/
PROCESS_THREAD(hello_world_process, ev, data)
{
  PROCESS_BEGIN();
  // Initialisation des compteurs
  count = 1;
  blinks = 1;

  while(1) {// Création d'une boucle infinie
    etimer_set(&et_hello, CLOCK_SECOND*20); // On démarre le timer
    PROCESS_WAIT_EVENT_UNTIL(ev == PROCESS_EVENT_TIMER); // Et on attends 20s

    printf("[Exemple] Cycle : #%u\n", count); // On affiche le numéro du cycle
    count++;

    leds_off(LEDS_ALL); // On éteint toute les LEDs
    if (blinks==1){
      leds_on(LEDS_BLUE);
      printf("[Exemple] Passage au bleu\n");
    }
    else if (blinks==2){
      leds_on(LEDS_RED);
      printf("[Exemple] Passage au rouge\n");
    }
    else if (blinks==3){
      leds_on(LEDS_GREEN);
      printf("[Exemple] Passage au vert\n");
      blinks=0;
    }
    blinks++;
  }

  PROCESS_END();
}
/*---------------------------------------------------------------------------*/
